unit FileNameProperty;
(***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is FileNameProperty.pas .

The Initial Developer of the Original Code is
Florian Kberle.
Portions created by the Initial Developer are Copyright (C) 2004
the Initial Developer. All Rights Reserved.

Contributor(s):

***** END LICENSE BLOCK *****)
interface
uses Forms,Dialogs, Classes,Sysutils,dsgnintf;
type
 TFileNameProperty = class (TPropertyEditor)
  public
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
    procedure SetValue(const Value: string); override;
    function AllEqual: Boolean; override;
    procedure Edit; override;
  end;

procedure Register;

implementation

function TFileNameProperty.AllEqual: Boolean;
var
 Nr1:String;
 I:Integer;
begin
 AllEqual := true;
 Nr1 := GetstrValue ;

 for I:= 1 to PropCount-1 do
 if Nr1 <>  GetstrValueat(I) then
  begin
   AllEqual := false;
   break;
  end;
end;

function TFileNameProperty.GetValue: string;
begin
 result  :=  GetStrValue ;
end;
procedure TFileNameProperty.SetValue(const Value: string);
begin
 SetStrValue(Value);
end;

procedure TFileNameProperty.Edit;
var
  OpenDialog:TOpenDialog;
begin
 OpenDialog  := TOpenDialog.create(Application);
 try
  OpenDialog.FileName := GetstrValue;
  if OpenDialog.Execute then SetstrValue(OpenDialog.FileName);
 finally
  OpenDialog.Free;
 end;
end;



function TFileNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog{paReadOnly }	];
end;


procedure Register;
begin
 RegisterPropertyEditor(TypeInfo(TFileName),nil,'FileName',TFileNameProperty);
end;

end.
