unit KomponentenEditorBeispiel;

interface
uses Graphics,dsgnintf,Dialogs,menus;
procedure Register;

implementation
uses Viereck;
  type

  // Dieser Komponenten Editor soll nur demonstrieren,
  // wie man Menus erzeugt.
  TFarbAuswahlComponentEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure PrepareItem(Index: Integer; const AItem: TMenuItem);override;
    procedure MeineEreignis(Sender:TObject);
  end;
procedure TFarbAuswahlComponentEditor.MeineEreignis(Sender:TObject);
begin
  ShowMessage('Ein Farbschema');
end;
procedure TFarbAuswahlComponentEditor.PrepareItem(Index: Integer; const AItem: TMenuItem);
var
  MyMenuItem:TMenuItem;
begin
  inherited;
  Case Index of
   0: AItem.Enabled := False; //Einfach mal deaktivieren
   1:
   begin
     MyMenuItem := TMenuItem.create(AItem);
     AItem.Add(MyMenuItem);
     MyMenuItem.Caption := 'Info';
     MyMenuItem.onClick := MeineEreignis;
   end;
  end;
end;

function TFarbAuswahlComponentEditor.GetVerbCount: Integer;
begin
  result := 3;//Anzahl der Menupunkte; In unserm Fall drei (0..2)
end;
function TFarbAuswahlComponentEditor.GetVerb(Index: Integer): string;
begin
  Case Index of
    0:   Result := '?' ;
    1:   Result := 'Farbenauswahl 2' ;
    2:   Result := 'Farbenauswahl 3';
    else
     Result := '?';
  end;
end;

procedure TFarbAuswahlComponentEditor.ExecuteVerb(Index: Integer);
begin
  if not (Component is TViereck) then
  begin
    ShowMessage('Dieser Komponenten Editor ist nicht TViereck zugeordnet');
  end
  else
  Case Index of
    0://Klick auf den Ersten Menu Punkt
    begin
      (Component as TViereck).Farben.Rahmen := clBlack;
      (Component as TViereck).Farben.Innen := clwhite;
    end;
    1://Klick auf den zweiten Menu Punkt
    begin
      (Component as TViereck).Farben.Rahmen := clYellow;
      (Component as TViereck).Farben.Innen := clNavy;
    end;
    2://Klick auf den dritten Menu Punkt
    begin
      (Component as TViereck).Farben.Rahmen := clBtnFace ;
      (Component as TViereck).Farben.Innen := clBtnFace	;
    end;
    else
     ShowMessage('Diesen Menupunkt gibt es nicht');
  end;
end;

procedure Register;
begin
  RegisterComponentEditor(TViereck, TFarbauswahlComponentEditor);
end;

end.
