unit LaufSchrift;
(***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is LaufSchrift.pas .

The Initial Developer of the Original Code is
Florian Kberle.
Portions created by the Initial Developer are Copyright (C) 2004
the Initial Developer. All Rights Reserved.

Contributor(s):

***** END LICENSE BLOCK *****)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TLaufSchrift = class(TCustomControl)
  private
    FNews:TStrings;
    FVisibleText:String;
    FVerschoben:Integer;
    FAktuelleZeile:Integer;
    FTrennZeichen:String;
    FSpeed:Word;
    FInterval:Word;
    procedure SetNews(News:TStrings);
    procedure SetInterval(NewInterval:Word);
    procedure Schrifterrechnen;
    procedure WMTimer(var Message:TWMTimer);message WM_TIMER;
  protected
    procedure Paint;override;
    procedure CreateWnd;override;
  public
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    property AktuelleZeile:Integer read FAktuelleZeile write FAktuelleZeile;
    property VisibleText:String read FVisibleText write FVisibleText;
  published
    property News:TStrings read FNews write SetNews;
    //property Color:TColor read FColor write FColor;
    property TrennZeichen:String read FTrennZeichen write FTrennZeichen;
    property Speed:Word read FSpeed write FSpeed;
    property Interval:Word read FInterval write SetInterval;
    property ParentFont;
    property Font;
    property Color;
    property ParentColor;
  end;

procedure Register;

implementation
const
 My_TimerID = 1;
 My_TimerInterval= 50;
 KeineNachrichten='Keine Nachrichten vorhanden';
procedure Register;
begin
  RegisterComponents('Tutorial', [TLaufSchrift]);
end;

constructor TLaufSchrift.Create(AOwner:TComponent);
begin
 inherited;
 FNews := TStringList.Create;//Die Klasse TStrings ist abstract.
 DoubleBuffered := True;
 FTrennZeichen := ' *** ';
 FSpeed := 2;
 FInterval := 50;
 ControlStyle := ControlStyle - [csAcceptsControls, csSetCaption] + [csFramed, csOpaque];

end;
procedure TLaufSchrift.CreateWnd;
begin
 inherited;
 SetTimer(Handle ,My_TimerID,FInterval,nil);//WM_Timer Botschaften anfodern
end;

destructor TLaufSchrift.Destroy;
begin
 FNews.Free;
 inherited;
end;

procedure TLaufSchrift.Paint;
begin
 inherited;
 Schrifterrechnen;
 canvas.Brush.Color := Color;
 Canvas.Font.Assign(Font);
 canvas.Pen.Style := psClear;
 canvas.Rectangle(0,0,width+1,height+1);
 canvas.TextOut(1-FVerschoben,1,FVisibleText);
end;

procedure TLaufSchrift.Schrifterrechnen;
begin
  if Length(FVisibleText) = 0 then FVisibleText := ' ';
  while FVerschoben >= canvas.Textwidth(FVisibleText[1]) do
  begin
   FVerschoben := FVerschoben - canvas.Textwidth(FVisibleText[1]);
   //Den ersten Buchstaben lschen
   FVisibleText := copy(FVisibleText,2,Length(FVisibleText)-1);
   //Weitere Nachrichten anzeigen
   while (canvas.Textwidth(FVisibleText) < ClientWidth) do
   if News.Count > 0 then
   begin
    FAktuelleZeile := FAktuelleZeile +1;
    if FAktuelleZeile = News.Count then FAktuelleZeile := 0;
    FVisibleText := FVisibleText + FTrennZeichen + News[FAktuelleZeile];
   end
   else
   FVisibleText := FVisibleText + FTrennZeichen + KeineNachrichten;
  end;
end;

{------------------------------------------------------------------------------}
//                     Windows Botschaften
{------------------------------------------------------------------------------}
procedure TLaufSchrift.WMTimer(var Message:TWMTimer);
begin
 if Message.TimerID = My_TimerID then
 begin
  FVerschoben := FVerschoben+FSpeed;
  Refresh;
  Invalidate;//Nach bearbeitung wichtiger Botschaften neu zeichnen
 end
 else //Unbekannte TimerID
  inherited;//Die Vorfahren werden nach einer Methode mit der gleichen BotschaftsID durchsucht.
end;

{------------------------------------------------------------------------------}
//                           procedure Set...
{------------------------------------------------------------------------------}
procedure TLaufSchrift.SetNews(News:TStrings);
begin
 FNews.Assign(News);
end;


procedure TLaufSchrift.SetInterval(NewInterval:Word);
begin
 FInterval := NewInterval;
 SetTimer(Handle ,My_TimerID,FInterval,nil);//WM_Timer Botschaften korrigieren
end;


end.
