unit Viereck;
(***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is Viereck.pas .

The Initial Developer of the Original Code is
Florian Kberle.
Portions created by the Initial Developer are Copyright (C) 2004
the Initial Developer. All Rights Reserved.

Contributor(s):

***** END LICENSE BLOCK *****)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type

  TViereckFarben=class;//Vorwrtsdeklaration

  TViereck = class(TGraphicControl)
  private
   FFarben:TViereckFarben;
   procedure SetFarben(NeueFarben:TViereckFarben);
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
  published
    property Farben:TViereckFarben read FFarben write SetFarben;
  end;


  TViereckFarben=class(TPersistent)
  private
    FRahmen:TColor;
    FInnen:TColor;
    procedure SetInnen(NewColor:TColor);
    procedure SetRahmen(NewColor:TColor);
  public
    OnChange:procedure of object;
  published
    property Rahmen:TColor read FRahmen write SetRahmen;
    property Innen:TColor  read FInnen  write SetInnen;
  end;

procedure Register;

implementation

procedure TViereck.SetFarben(NeueFarben:TViereckFarben);
begin
 FFarben.Assign(NeueFarben);
 // Wichtig: Nur die Farben werden bernommen.
 // Der Zeiger zeigt aber trotzdem noch auf die gleiche Instanz der Klasse.
end;
procedure TViereckFarben.SetInnen(NewColor:TColor);
begin
 FInnen:= NewColor;
 if Assigned(@OnChange) then OnChange; //Benachtrichtigen des Besitzers
end;

procedure TViereckFarben.SetRahmen(NewColor:TColor);
begin
 FRahmen := NewColor;
 if Assigned(@OnChange) then OnChange;
end;

Constructor TViereck.Create(AOwner:TComponent);
begin
 inherited;
 FFarben := TViereckFarben.Create;
 FFarben.OnChange := Refresh; //Neuzeichenen falls sich die Farben ndern
 FFarben.Innen := clwhite;
end;

destructor TViereck.destroy;
begin
 inherited;
 FFarben.free;
end;

procedure TViereck.Paint;
begin
 Canvas.Brush.Color := Farben.Innen;
 Canvas.pen.Color := Farben.Rahmen;
 Canvas.Rectangle(0,0,Width,Height);
end;

procedure Register;
begin
  RegisterComponents('Tutorial', [TViereck]);
end;

end.
 